/*     karte_cgi (map_cgi) is interactively calculating maps  */
/*     via a web-interface  */

/*     Copyright (C) 2001  Marcus Lindemann (ml@ma3s.de) */

/*     This program is free software; you can redistribute it and/or modify */
/*     it under the terms of the GNU General Public License version 2 as */
/*     published by the Free Software Foundation. */

/*     This program is distributed in the hope that it will be useful, */
/*     but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the */
/*     GNU General Public License for more details. */

/*     You should have received a copy of the GNU General Public License */
/*     along with this program (file LICENSE); if not, write to the */
/*     Free Software Foundation, Inc., 59 Temple Place, Suite 330,  */
/*     Boston, MA  02111-1307  USA */


#include "karte.h"
int center_calc(int , Point *, IM *, IM *);

BIT32 center(Point *pt, IM *orig_img, IM *img)
{
    BIT32 i=0;

    trans_init(orig_img);

    do{
      center_calc(i, pt, orig_img, img);
      i++;
    } while (img->center.lam==HUGE_VAL);

    pj_free(orig_img->pj);
    return (i-1);
}

int center_calc(int i, Point *pt, IM *orig_img, IM *img)
{
    projUV p;

    p.u = (double)(pt->x - orig_img->width/2 + orig_img->offset.x)
          /(orig_img->zoom*(orig_img->scale+i));
    p.v = (double)(orig_img->high/2 - pt->y + orig_img->offset.y)
          /(orig_img->zoom*(orig_img->scale+i));

    p = pj_inv(p, orig_img->pj);

    img->center.lam = RAD_TO_DEG*p.u;
    img->center.phi = RAD_TO_DEG*p.v;

    return 0;
}
