/*     karte_cgi (map_cgi) is interactively calculating maps  */
/*     via a web-interface  */

/*     Copyright (C) 2001  Marcus Lindemann (ml@ma3s.de) */

/*     This program is free software; you can redistribute it and/or modify */
/*     it under the terms of the GNU General Public License version 2 as */
/*     published by the Free Software Foundation. */

/*     This program is distributed in the hope that it will be useful, */
/*     but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the */
/*     GNU General Public License for more details. */

/*     You should have received a copy of the GNU General Public License */
/*     along with this program (file LICENSE); if not, write to the */
/*     Free Software Foundation, Inc., 59 Temple Place, Suite 330,  */
/*     Boston, MA  02111-1307  USA */

#include "karte.h"

void id(char *i_id)
{
    int pid; 
    time_t t;
    struct tm *tp;

    t=time(NULL);
    tp=gmtime(&t);

    strftime(i_id, 255, "%j%H%M%S",tp); 
    pid=(int) getpid();
    
    sprintf(i_id, "%s%d", i_id, pid); 
}

void pt_init(Point *pt)
{
  cgiFormInteger("welt.x", &pt->x, IMG_WIDTH/2);
  cgiFormInteger("welt.y", &pt->y, IMG_HIGH/2);
}

void im_init(IM *orig_img, IM *img, VW *vw)
{
    int background; 

    orig_img->width=img->width=IMG_WIDTH;
    orig_img->high=img->high=IMG_HIGH;

    img->im = gdImageCreate(img->width, img->high);
    background = gdImageColorAllocate(img->im, 255, 255, 255);    

    cgiFormInteger("orig_proj", &orig_img->proj, 0);
    orig_img->scale=orig_img->pr[orig_img->proj].scale;

    cgiFormInteger("orig_zoom", &orig_img->zoom, 1);
    cgiFormInteger("x_offset", &orig_img->offset.x, 0);
    cgiFormInteger("y_offset", &orig_img->offset.y, 0);
    cgiFormDouble("orig_lam", &orig_img->center.lam, 0);
    cgiFormDouble("orig_phi", &orig_img->center.phi, 0);

    cgiFormInteger("proj", &img->proj, 0);
    img->scale=img->pr[img->proj].scale;

    cgiFormInteger("zoom", &vw->z, 1);

    if (vw->z > 0){
	img->zoom=(int)(vw->z*orig_img->zoom);
    }
    else if(vw->z < 0){
	img->zoom=(int)(-1*orig_img->zoom/vw->z);
    }
    else{
	img->zoom=1;
    }
    if (img->zoom<1){
	img->zoom=1;
    }
}
