/*     karte_cgi (map_cgi) is interactively calculating maps  */
/*     via a web-interface  */

/*     Copyright (C) 2001  Marcus Lindemann (ml@ma3s.de) */

/*     This program is free software; you can redistribute it and/or modify */
/*     it under the terms of the GNU General Public License version 2 as */
/*     published by the Free Software Foundation. */

/*     This program is distributed in the hope that it will be useful, */
/*     but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the */
/*     GNU General Public License for more details. */

/*     You should have received a copy of the GNU General Public License */
/*     along with this program (file LICENSE); if not, write to the */
/*     Free Software Foundation, Inc., 59 Temple Place, Suite 330,  */
/*     Boston, MA  02111-1307  USA */

#include "karte.h"

int cgi_out(IM *img, VW *vw, Content *con, char *i_id)
{
 fprintf(cgiOut, "<center>\n"); 
 fprintf(cgiOut, "<br>Zoom: %d<br><br>Center Lon: %.2f, Lat: %.2f", img->zoom, 
	          img->center.lam, img->center.phi);  
 fprintf(cgiOut, "</center>\n");
 //---------------
 fprintf(cgiOut, "<form method=\"POST\" action=\"http://%s/karte_cgi\">\n<br>\n", PATH);
 //---------------
 fprintf(cgiOut, "<input type=\"hidden\" name=\"regular\" value=\"1\">\n");
 fprintf(cgiOut, "<input type=\"hidden\" name=\"orig_proj\" value=\"%d\">\n"
        , img->proj);
 fprintf(cgiOut, "<input type=\"hidden\" name=\"orig_zoom\" value=\"%d\">\n"
        , img->zoom);
 fprintf(cgiOut, "<input type=\"hidden\" name=\"orig_lam\" value=\"%f\">\n"
        , img->center.lam);
 fprintf(cgiOut, "<input type=\"hidden\" name=\"orig_phi\" value=\"%f\">\n"
        , img->center.phi);
 fprintf(cgiOut, "<input type=\"hidden\" name=\"x_offset\" value=\"%d\">\n"
        , img->offset.x);
 fprintf(cgiOut, "<input type=\"hidden\" name=\"y_offset\" value=\"%d\">\n"
        , img->offset.y);
//----------------
 fprintf(cgiOut, "<table width=100%% border=0>\n<tr bgcolor=#EEEEEE>\n");
 fprintf(cgiOut, "<td align=center><input type=checkbox name=\"opt\" %s value=\"0\"> color</td>\n", checked(vw->opt[0]));
 fprintf(cgiOut, "<td align=center><input type=checkbox name=\"opt\" %s value=\"1\"> turn</td>\n", checked(vw->opt[1]));
 fprintf(cgiOut, "<td align=center><input type=checkbox name=\"opt\" %s value=\"2\"> deco</td>\n", checked(vw->opt[2]));
 fprintf(cgiOut, "</tr>\n<tr>\n<td align=left>\n");
 //---------------
 fprintf(cgiOut, "<select name=\"zoom\" size=7>\n");
 fprintf(cgiOut, "<option value=\"25\" %s> x 25\n", msel(25, vw->z));
 fprintf(cgiOut, "<option value=\"10\" %s> x 10\n", msel(10, vw->z));
 fprintf(cgiOut, "<option value=\"5\" %s> x 5\n", msel(5, vw->z));
 fprintf(cgiOut, "<option value=\"2\" %s> x 2\n", msel(2, vw->z));
 fprintf(cgiOut, "<option value=\"1\" %s> x 1\n", msel(1, vw->z));
 fprintf(cgiOut, "<option value=\"-2\" %s> / 2\n", msel(-2, vw->z));
 fprintf(cgiOut, "<option value=\"-5\" %s> / 5\n", msel(-5, vw->z));
 fprintf(cgiOut, "<option value=\"-10\" %s> / 10\n", msel(-10, vw->z));
 fprintf(cgiOut, "<option value=\"-25\" %s> / 25\n", msel(-25, vw->z));
 fprintf(cgiOut, "</select>\n</td>\n");
 //---------------
 fprintf(cgiOut, "<td rowspan=2 align=center><input type=\"image\" src=\"%s%s.png\"  name=\"welt\" border=\"1\"></td>\n", IMG_PREFIX_SERV,i_id);
 //---------------
 fprintf(cgiOut, "<td align=right>\n<select name=\"proj\" size=7>\n");
 fprintf(cgiOut, "<option value=\"0\" %s> Mollweide\n", msel(0, img->proj));
 fprintf(cgiOut, "<option value=\"1\" %s> Orthogonal\n", msel(1, img->proj));
 fprintf(cgiOut, "<option value=\"2\" %s> Sinusoidal\n", msel(2, img->proj));
 fprintf(cgiOut, "<option value=\"3\" %s> Mercator\n", msel(3, img->proj));
 fprintf(cgiOut, "<option value=\"4\" %s> Transverse Mercator\n", 
         msel(4, img->proj));
 fprintf(cgiOut, "<option value=\"5\" %s> Gnomonic\n", 
         msel(5, img->proj));
 fprintf(cgiOut, "<option value=\"6\" %s> Eckert IV\n", msel(6, img->proj));
 fprintf(cgiOut, "<option value=\"7\" %s> Eckert VI\n", msel(7, img->proj));
 fprintf(cgiOut, "<option value=\"8\" %s> van der Grinten\n", 
         msel(8, img->proj));
 fprintf(cgiOut, "</select></td>\n");
 //---------------
 fprintf(cgiOut, "</tr>\n<tr>\n");
 fprintf(cgiOut, "<td align=left><input type=submit name=\"re\" value=\"recompute\"></td>\n");
 //---------------
 fprintf(cgiOut, "<td align=right><input type=submit name=\"w\" value=\"world\"></td>\n");
 fprintf(cgiOut, "</tr>\n<tr bgcolor=#EEEEEE>\n<td align=left>\n");
 //---------------
 fprintf(cgiOut, "<select name=\"cil\" size=4 multiple>\n");
 fprintf(cgiOut, "<option value=\"1\" %s> Coast, major islands, lakes\n", 
         sel(1, con->cil));
 fprintf(cgiOut, "<option value=\"2\" %s> More major islands, lakes\n",
         sel(2, con->cil));
 fprintf(cgiOut, "<option value=\"3\" %s> Intermediate islands, lakes\n",
         sel(3, con->cil));
 fprintf(cgiOut, "<option value=\"4\" %s> Minor islands, lakes\n",
         sel(4, con->cil));
 fprintf(cgiOut, "<option value=\"6\" %s> Intermittent major lakes\n",
         sel(6, con->cil));
 fprintf(cgiOut, "<option value=\"7\" %s> Intermittent minor lakes\n",
         sel(7, con->cil));
 fprintf(cgiOut, "<option value=\"8\" %s> Reefs\n",
         sel(8, con->cil));
 fprintf(cgiOut, "<option value=\"9\" %s> Salt pans, major\n",
         sel(9, con->cil));
 fprintf(cgiOut, "<option value=\"10\" %s> Salt pans, minor\n",
         sel(10, con->cil));
 fprintf(cgiOut, "<option value=\"13\" %s> Ice Shelves, major\n",
         sel(13, con->cil));
 fprintf(cgiOut, "<option value=\"14\" %s> Ice Shelves, minor\n",
         sel(14, con->cil));
 fprintf(cgiOut, "<option value=\"15\" %s> Glaciers\n",
         sel(15, con->cil));
 fprintf(cgiOut, "</select></td>\n<td align=center>\n");
 //---------------
 fprintf(cgiOut, "<select name=\"riv\" size=4 multiple>\n");
 fprintf(cgiOut, "<option value=\"1\" %s> Permanent major rivers\n",
         sel(1, con->riv));
 fprintf(cgiOut, "<option value=\"2\" %s> More major rivers\n",
         sel(2, con->riv));
 fprintf(cgiOut, "<option value=\"3\" %s> More rivers\n",
         sel(3, con->riv));
 fprintf(cgiOut, "<option value=\"4\" %s> Minor rivers\n",
         sel(4, con->riv));
 fprintf(cgiOut, "<option value=\"5\" %s> Double lined rivers\n",
         sel(5, con->riv));
 fprintf(cgiOut, "<option value=\"6\" %s> Intermittent rivers, major\n",
         sel(6, con->riv));
 fprintf(cgiOut, "<option value=\"7\" %s> Intermittent rivers, more\n",
         sel(7, con->riv));
 fprintf(cgiOut, "<option value=\"8\" %s> Intermittent rivers, minor\n",
         sel(8, con->riv));
 fprintf(cgiOut, "<option value=\"10\" %s> Major canals\n",
         sel(10, con->riv));
 fprintf(cgiOut, "<option value=\"11\" %s> Canals, lesser importance\n",
         sel(11, con->riv));
 fprintf(cgiOut, "<option value=\"13\" %s> Canals, irrigation type\n",
         sel(13, con->riv));
 fprintf(cgiOut, "</select></td>\n<td align=right>\n");
 //---------------
 fprintf(cgiOut, "<select name=\"bdy\" size=4 multiple>\n");
 fprintf(cgiOut, "<option value=\"1\" %s> Boundary\n",
         sel(1, con->bdy));
 fprintf(cgiOut, "<option value=\"2\" %s> Indefinite or in Dispute\n",
         sel(2, con->bdy));
 fprintf(cgiOut, "<option value=\"3\" %s> Other line of separation\n",
         sel(3, con->bdy));
 fprintf(cgiOut, "<option value=\"4\" %s> US Boundaries\n",
         sel(4, con->bdy));
 fprintf(cgiOut, "</select></td>\n</tr>\n</table>\n");
 //---------------
 fprintf(cgiOut, "</form>\n");

    return 0;
}

char *sel(int i, BIT32 *field)
{
    if(field[i]) return "selected";
    else return "";
}

char *msel(int i, int j)
{
    if(i==j) return "selected";
    else return "";
}

char *checked(int flag)
{
    if(flag) return "checked";
    else return "";
}
