/*     karte_cgi (map_cgi) is interactively calculating maps  */
/*     via a web-interface  */

/*     Copyright (C) 2001  Marcus Lindemann (ml@ma3s.de) */

/*     This program is free software; you can redistribute it and/or modify */
/*     it under the terms of the GNU General Public License version 2 as */
/*     published by the Free Software Foundation. */

/*     This program is distributed in the hope that it will be useful, */
/*     but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the */
/*     GNU General Public License for more details. */

/*     You should have received a copy of the GNU General Public License */
/*     along with this program (file LICENSE); if not, write to the */
/*     Free Software Foundation, Inc., 59 Temple Place, Suite 330,  */
/*     Boston, MA  02111-1307  USA */

#include "karte.h"

int deco(IM *img, VW *vw)
{
    int i,j,k,black;
    Point pt;
    CO gr;

    black=gdImageColorResolve(img->im, 0, 0, 0);

    img->range.min.lam=floor(img->range.min.lam);
    img->range.max.lam=ceil(img->range.max.lam);
    img->range.min.phi=floor(img->range.min.phi);
    img->range.max.phi=ceil(img->range.max.phi);

    if(img->zoom <4){k=20;}
    else{k=10;}


    for(i=-180; i<=180; i=i+k){
	if(img->range.min.lam<=i && img->range.max.lam>=i){
	    for(j=0; j<=PKT; j++){
	      gr.lam=i;
	      gr.phi=img->range.min.phi+
	      (img->range.max.phi-img->range.min.phi)*j/PKT;
              pt=transform( &gr, img);
              gdImageSetPixel(img->im, pt.x, pt.y, black); 
	    }
	}
          
    }

    for(i=-80; i<=80; i=i+k){
	if(img->range.min.phi<=i && img->range.max.phi>=i){
	    for(j=0; j<=PKT; j++){
	      gr.phi=i;
	      gr.lam=img->range.min.lam+
	      (img->range.max.lam-img->range.min.lam)*j/PKT;
              pt=transform( &gr, img);
              gdImageSetPixel(img->im, pt.x, pt.y, black); 
	    }
	}
          
    }

    return 0;
}

