/*     karte_cgi (map_cgi) is interactively calculating maps  */
/*     via a web-interface  */

/*     Copyright (C) 2001  Marcus Lindemann (ml@ma3s.de) */

/*     This program is free software; you can redistribute it and/or modify */
/*     it under the terms of the GNU General Public License version 2 as */
/*     published by the Free Software Foundation. */

/*     This program is distributed in the hope that it will be useful, */
/*     but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the */
/*     GNU General Public License for more details. */

/*     You should have received a copy of the GNU General Public License */
/*     along with this program (file LICENSE); if not, write to the */
/*     Free Software Foundation, Inc., 59 Temple Place, Suite 330,  */
/*     Boston, MA  02111-1307  USA */

#ifndef __INIT_H__
#define __INIT_H__


#define IMG_WIDTH 360
#define IMG_HIGH 180

#define CUT 25    // cut for calculating only every (CUT/zoom)th point 
                  // if zoom < CUT
#define PKT 150   // number of points for every line of the grid in deco

#define PATH "localhost/cgi-bin" // host and cgi-Path
#define IMG_PREFIX "/var/www/html/tmp/welt" // prefix for output images 
                                            // (cgi view) 
#define IMG_PREFIX_SERV "/tmp/welt"     // prefix for output images 
                                        // (server view) 
#define HELP "../help.html"                // help text
 
#define EARTH "dat/earth.rez"           // vector data
#define STANDARD "dat/karte.html"       // standard page
#define TURN_ROT "dat/rot_lonlat.txt"   // waypoints of the red boot
#define TURN_GELB "dat/gelb_lonlat.txt" // waypoints of the yellow boot

// -------------------- do not change below --------------

#define HEADER_MAGIC 0x86460346	//random number that Reza Naima has chosen

// The following are the Continent Codes
#define AFRICA 1
#define ASIA 2
#define EUROPE 3
#define NORTH_AMERICA 4
#define SOUTH_AMERICA 5

// And these are the categories
#define PBY 1  
#define RIV 2  
#define BDY 3
#define CIL 4 // <- 5 in original data set?

// category  type       meaning

//US Boundaries
// 1         01         No Idea
// 1         03         No Idea

//International Boundaries
// 3         01         Demarcated or delimited boundary
// 3         02         Indefinite or in Dispute
// 3         03         Other line of separation of sovreignty on land

//In "Coast, Islands and Lakes" files (cil)
// 4         01         Coast, islands and lakes that appear on all maps
// 4         02         Additional major islands and lakes
// 4         03         Intermediate islands and lakes
// 4         04         Minor islands and lakes
// 4         06         Intermittent major lakes
// 4         07         Intermittent minor lakes
// 4         08         Reefs
// 4         09         Salt pans -- major
// 4         10         Salt pans -- minor
// 4         13         Ice Shelves -- major
// 4         14         Ice Shelves -- minor
// 4         15         Glaciers

//In "Rivers" files (riv)
// 2         01         Permanent major rivers
// 2         02         Additional major rivers
// 2         03         Additional rivers
// 2         04         Minor rivers
// 2         05         Double lined rivers
// 2         06         Intermittent rivers -- major
// 2         07         Intermittent rivers -- additional
// 2         08         Intermittent rivers -- minor
// 2         10         Major canals
// 2         11         Canals of lesser importance
// 2         13         Canals -- irrigation type

#endif /* __INIT_H__ */
