/*     karte_cgi (map_cgi) is interactively calculating maps  */
/*     via a web-interface  */

/*     Copyright (C) 2001  Marcus Lindemann (ml@ma3s.de) */

/*     This program is free software; you can redistribute it and/or modify */
/*     it under the terms of the GNU General Public License version 2 as */
/*     published by the Free Software Foundation. */

/*     This program is distributed in the hope that it will be useful, */
/*     but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the */
/*     GNU General Public License for more details. */

/*     You should have received a copy of the GNU General Public License */
/*     along with this program (file LICENSE); if not, write to the */
/*     Free Software Foundation, Inc., 59 Temple Place, Suite 330,  */
/*     Boston, MA  02111-1307  USA */

#include "karte.h"

void html_head();
void html_foot();

// main
int cgiMain() 
{
    int regular;

    // if called without parameters, output standard page
    if(cgiFormNotFound == cgiFormInteger("regular", &regular, 0)){
        standard_out();
    }
    // otherwise...
    else{
        karte_out();
    }
    return 0;
}

void standard_out()
{
    char buf[256];
    FILE *fp;

    if((fp=fopen(STANDARD, "r"))==NULL){
        fprintf(stderr, "Can't open standard.");
        exit(2);
    }

    cgiHeaderContentType("text/html");

    while (fgets(buf, 256, fp)){
        fputs(buf, cgiOut);
    }
    fclose(fp);    
}

void karte_out()
{
    char i_id[256], world[77], re[77];
    Point pt;
    IM orig_img, img;
    VW vw;

    html_head();             // print html-head
    id(i_id);                // calculate image-id
   
    pr_init(&img);           // read in standard values for projections
    pr_init(&orig_img);      // name, scale factor, width/high, ...
    im_init(&orig_img, &img, &vw);  
    
    if(cgiFormSuccess == cgiFormString("re" , re, 76)){
	img.center=orig_img.center;
    }  
    else if(cgiFormSuccess == cgiFormString("w" , world, 76)){
        img.center.lam = img.center.phi = 0.0;
        img.zoom=1;
    }
    else{
        pt_init(&pt);                 // read in x/y clicked
        center(&pt, &orig_img, &img); // calculate Lon/Lat of new 
                                      // image center
    }

    map(i_id, &img, &vw);    // put out map image, change to new offset

    html_foot();
}
