/*     karte_cgi (map_cgi) is interactively calculating maps  */
/*     via a web-interface  */

/*     Copyright (C) 2001  Marcus Lindemann (ml@ma3s.de) */

/*     This program is free software; you can redistribute it and/or modify */
/*     it under the terms of the GNU General Public License version 2 as */
/*     published by the Free Software Foundation. */

/*     This program is distributed in the hope that it will be useful, */
/*     but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the */
/*     GNU General Public License for more details. */

/*     You should have received a copy of the GNU General Public License */
/*     along with this program (file LICENSE); if not, write to the */
/*     Free Software Foundation, Inc., 59 Temple Place, Suite 330,  */
/*     Boston, MA  02111-1307  USA */

#include "karte.h"

int trans_init(IM *img)
{ 
    PJ *trans; /* pointer to transformation function */
    char *args[7], lon[77], lat[77];
     
    sprintf(lon,"lon_0=%.4f",img->center.lam); /* lon_0 */
    sprintf(lat,"lat_0=%.4f",img->center.phi); /* lat_0 */    

    args[0]=img->pr[img->proj].name;
    args[1]="R=1";
    args[2]=lon;
    args[3]=lat;

    if (!(trans = pj_init(4, args))){
	       printf("Error initializing projection\n");
               exit(1);
    }
    img->pj=trans;

    return 0;
}

int offset_init(IM *img)
{ 
    img->offset.x=0;  // init value for transform
    img->offset.y=0;  // ...

    img->offset=transform(&img->center, img);

    img->offset.x=img->offset.x-img->width/2;
    img->offset.y=img->high/2-img->offset.y;

    return 0;
}
