/*     karte_cgi (map_cgi) is interactively calculating maps  */
/*     via a web-interface  */

/*     Copyright (C) 2001  Marcus Lindemann (ml@ma3s.de) */

/*     This program is free software; you can redistribute it and/or modify */
/*     it under the terms of the GNU General Public License version 2 as */
/*     published by the Free Software Foundation. */

/*     This program is distributed in the hope that it will be useful, */
/*     but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the */
/*     GNU General Public License for more details. */

/*     You should have received a copy of the GNU General Public License */
/*     along with this program (file LICENSE); if not, write to the */
/*     Free Software Foundation, Inc., 59 Temple Place, Suite 330,  */
/*     Boston, MA  02111-1307  USA */

#include "karte.h"

int route(IM *img, VW *vw)
{  
  FILE *ROT, *GELB;
  float lon, lat;
  CO dat;
  Point pt1, pt2;
  int red, black, flag;

  red=gdImageColorResolve(img->im, 255, 0, 0);
  black=gdImageColorResolve(img->im, 0, 0, 0);

  if((ROT=fopen(TURN_ROT, "r"))==NULL){
    fprintf(stderr, "Can't open rot.");
  }
  if((GELB=fopen(TURN_GELB, "r"))==NULL){
    fprintf(stderr, "Can't open gelb.");
  }
  
  flag=0;
  while(fscanf(GELB, "%f %f", &lon, &lat) != EOF){
      dat.lam=(double)(lon);
      dat.phi=(double)(lat);
      pt1=transform( &dat, img);

      if(pt1.x<0 || pt1.x>img->width || pt1.y<0 || pt1.y>img->high){
	  if(flag==2){
	      gdImageLine(img->im, pt1.x, pt1.y, pt2.x, pt2.y, black);
              flag=0;
	  } 
          pt2=pt1;
          flag=1; 
	 continue;
      } 

      if (flag==0){pt2=pt1; flag=1; continue;}

      gdImageLine(img->im, pt1.x, pt1.y, pt2.x, pt2.y, black);
      pt2=pt1;
      flag=2; 
  }

  flag=0;
  while(fscanf(ROT, "%f %f", &lon, &lat) != EOF){
      dat.lam=(double)(lon);
      dat.phi=(double)(lat);
      pt1=transform( &dat, img);

      if(pt1.x<0 || pt1.x>img->width || pt1.y<0 || pt1.y>img->high){
	  if(flag==2){
	      gdImageLine(img->im, pt1.x, pt1.y, pt2.x, pt2.y, red);
              flag=0;
	  } 
          pt2=pt1;
          flag=1; 
	 continue;
      } 

      if (flag==0){pt2=pt1; flag=1; continue;}

      gdImageLine(img->im, pt1.x, pt1.y, pt2.x, pt2.y, red);
      pt2=pt1;
      flag=2; 
  }

  fclose(ROT);
  fclose(GELB);
  
  return 0;
}
